<template>
  <div class="p-2">
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="30%" :draggable="draggable">
      <el-form ref="formRef" v-loading="formLoading" :model="formData" :rules="formRules" label-width="120px">
        <el-form-item label="所属结算账户" prop="accountId">
          <el-select v-model="formData.accountId" filterable placeholder="请选择所属结算账户">
            <el-option
              v-for="item in accountOptions"
              :key="item.accountId"
              :label="item.accountName"
              :value="item.accountId"
              :disabled="false"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="营业员名称" prop="operatorName">
          <el-input v-model="formData.operatorName" placeholder="请输入营业员名称" />
        </el-form-item>
        <el-form-item label="卡流水号" prop="cardNumber">
          <el-input v-model="formData.cardNumber" placeholder="请输入卡流水号" />
        </el-form-item>
        <el-form-item label="物理卡号" prop="factoryId">
          <el-input v-model="formData.factoryId" placeholder="请输入物理卡号" />
        </el-form-item>
        <el-form-item label="营业员卡密码" prop="cardPwd">
          <el-input v-model="formData.cardPwd" placeholder="请输入营业员卡密码" />
        </el-form-item>
        <el-form-item label="营业员卡有效期" prop="lifespan">
          <el-date-picker v-model="formData.lifespan" clearable type="datetime" value-format="YYYY-MM-DD HH:mm:ss" placeholder="请选择营业员卡有效期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="formData.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="formLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="dialog.visible = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PtOperatorForm" lang="ts">
import { PtAccountVO } from '@/api/basics/merchant/ptAccount/types';
import * as PtOperatorApi from '@/api/basics/merchant/ptOperator';
import { PtOperatorForm } from '@/api/basics/merchant/ptOperator/types';
import { listPtAccount } from '@/api/basics/merchant/ptAccount';
import { useI18n } from 'vue-i18n';

defineOptions({ name: 'PtOperatorForm' });

// 接收父组件传入属性
// const props = defineProps({})

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
// 国际化
const { t } = useI18n();

// 对话框
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
// 窗体是否可以拖动
const draggable = ref(true);
// 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formLoading = ref(false);
// 表单的类型：create - 新增；update - 修改
const formType = ref('');
// 表单引用
const formRef = ref<ElFormInstance>();
// 表单数据
const formData = ref<PtOperatorForm>({
  operatorId: undefined,
  accountId: undefined,
  operatorName: '',
  cardNumber: undefined,
  factoryId: '',
  cardPwd: '',
  lifespan: undefined,
  remark: ''
});
const accountOptions = ref<PtAccountVO[]>([]);
// 表单校验规则
const formRules = reactive({
  operatorId: [{ required: true, message: '营业员Id,主键不能为空', trigger: 'blur' }],
  accountId: [{ required: true, message: '所属结算账户Id不能为空', trigger: 'blur' }],
  operatorName: [{ required: true, message: '营业员名称不能为空', trigger: 'blur' }]
  // cardPwd: [{ required: true, message: '营业员卡密码不能为空', trigger: 'blur' }]
  // lifespan: [{ required: true, message: '营业员卡有效期不能为空', trigger: 'blur' }]
});
/** 当前组件方法 */
/** 窗体打开事件 */
const open = async (type: string, id?: number) => {
  dialog.visible = true;
  dialog.title = t('action.' + type);
  formType.value = type;
  resetForm();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true;
    try {
      const res = await PtOperatorApi.getPtOperator(id);
      Object.assign(formData.value, res.data);
    } finally {
      formLoading.value = false;
    }
  }
};
/** 表单重置 */
const resetForm = () => {
  formData.value = {
    operatorId: undefined,
    accountId: undefined,
    operatorName: '',
    cardNumber: undefined,
    factoryId: '',
    cardPwd: '',
    lifespan: undefined,
    remark: ''
  };
  formRef.value?.resetFields();
};
// 传回给父组件的属性与方法
// 提供 open 方法，用于打开弹窗
defineExpose({ open });
/** 触发父组件的事件 */
/** 定义 success 事件，用于操作成功后的回调 */
const emit = defineEmits(['success']);
/** 提交按钮 */
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return;
  const valid = await formRef.value?.validate();
  if (!valid) return;
  // 提交请求
  formLoading.value = true;
  try {
    const data = formData.value as unknown as PtOperatorForm;
    if (formType.value === 'create') {
      await PtOperatorApi.addPtOperator(data);
      proxy?.$modal.msgSuccess('新增成功');
    } else {
      await PtOperatorApi.updatePtOperator(data);
      proxy?.$modal.msgSuccess('修改成功');
    }
    dialog.visible = false;
    // 发送操作成功的事件
    emit('success');
  } finally {
    formLoading.value = false;
  }
};

//查询账号信息
const getListAccount = () => {
  listPtAccount().then((res) => {
    accountOptions.value = res.rows;
  });
};

/** 初始化 */
onMounted(() => {
  getListAccount();
});
</script>
